import { getDicts } from '@/api/system/dict/data';
import { useDictStore } from '@/store/modules/dict';
import { ref, toRefs } from 'vue';

/**
 * 获取字典数据
 */
export const useDict = (...args: string[]) => {
  const res = ref<{
    [key: string]: DictDataOption[];
  }>({});

  args.forEach(async (dictType) => {
    res.value[dictType] = [];
    const dicts = useDictStore().getDict(dictType);
    if (dicts && dicts.length > 0) {
      res.value[dictType] = dicts;
    } else {
      await getDicts(dictType).then((resp) => {
        console.log(`[useDict] 加载字典类型: ${dictType}`, resp.data);
        res.value[dictType] = resp.data.map(
          (p): DictDataOption => ({ label: p.dictLabel, value: p.dictValue, elTagType: p.listClass, elTagClass: p.cssClass })
        );
        useDictStore().setDict(dictType, res.value[dictType]);
      });
    }
  });
  return toRefs(res.value);
};
